-- RBT-TEST - ДПРД для языков программирования
-- Проверка дискреционного разграничения доступа для языков программирования
-- Права доступа для языков программирования: USAGE
--
\i 'support/init.sql'
--
-- Общая подготовка
\connect - postgres
--
-- Отбираем у PUBLIC права на использование языка SQL
REVOKE ALL ON LANGUAGE sql FROM PUBLIC;
--
-- Подключение пользователя u_1_10
\connect - u_1_10
--
-- Попытка создать функцию на языке SQL
-- Ожидается ошибка доступа
CREATE FUNCTION test (BOOLEAN) RETURNS TEXT AS '
	SELECT CASE WHEN $1 THEN ''success'' ELSE ''fail'' END;
' LANGUAGE sql;
--
-- Администратор postgres дает право USAGE для пользователя u_1_10
\connect - postgres
GRANT USAGE ON LANGUAGE sql TO u_1_10;
--
-- Подключение пользователя u_1_10
\connect - u_1_10
--
-- Попытка создать функцию на языке SQL
-- Ожидается успех
CREATE FUNCTION test (BOOLEAN) RETURNS TEXT AS '
	SELECT CASE WHEN $1 THEN ''success'' ELSE ''fail'' END;
' LANGUAGE sql;
--
-- Проверяем факт создания функции
SELECT proname as "Наименование функции" from pg_proc WHERE oid = 'test'::regproc::oid;
--
-- Проверяем функцию путем ее выполнения
SELECT test(true);
--
\i 'support/done.sql'
