-- RBT-TEST - COPY TO STDOUT WITH MACS
-- Проверка работы МПРД при использовании команды COPY TO STDOUT WITH MACS
-- одновременно не может быть успешным или неуспешным прохождение этого теста и теста mac-wd-copy-std
--
\i 'support/init.sql'
\i 'support/create-test-table.sql'
\i 'support/init-test-table.sql'
\i 'support/select-test-table.sql'
--
-- Отбираем права у PUBLIC на тестовую таблицу
\connect - postgres
REVOKE ALL ON "Проверка" FROM PUBLIC;
--
-- Подключение пользователя u_0_00 c меткой {0,0}
\connect - u_0_00
--
-- Попытка выполнить команду COPY на экран
-- Ожидается ошибка доступа
COPY "Проверка" TO STDOUT;
--
-- Даем право на чтение, но устанавливаем метку таблицы в {1,0}
\connect - postgres
ALTER TABLE "Проверка" SET MAC TO '{1, 0}';
GRANT SELECT ON "Проверка" TO PUBLIC;
--
-- Подключение пользователя u_0_00 c меткой {0,0}
\connect - u_0_00
--
-- Попытка выполнить команду COPY на экран
-- Ожидается ошибка доступа
COPY "Проверка" TO STDOUT;
--
-- Откючаем мандатный контроль доступа на тестовую таблицу
\connect - postgres
ALTER TABLE "Проверка" SET MAC TO NULL;
--
-- Подключение пользователя u_0_00 c меткой {0,0}
\connect - u_0_00
--
-- Попытка выполнить команду COPY на экран
-- Ожидается две строки с метками {0,0}, при этом метки не выводятся
COPY "Проверка" TO STDOUT;
--
-- Попытка выполнить команду COPY с выводом меток на экран
-- Ожидается две строки с метками {0,0}, метки так же выводятся
COPY "Проверка" TO STDOUT WITH MACS;
--
-- Подключается пользователь dbsa с флагами игнорирования МПРД
\connect - dbsa
--
-- Попытка выполнить команду COPY с выводом меток на экран
-- Ожидаются все 10 строк
COPY "Проверка" TO STDOUT WITH MACS;
--
-- Подключается суперюзер postgres 
\connect - postgres
--
-- Очищаем таблицу
DELETE FROM "Проверка";
--
-- Подключение пользователя u_2_11 c меткой {2,3}
\connect - u_2_11
-- 
-- Пытаемся заполнить таблицу со стандартного потока ввода
-- Ожидается ошибка доступа, так как отсутствует права на вставку
COPY "Проверка" FROM STDIN;
--
-- Даем право на вставку, но устанавливаем метку таблицы в {1,1}
\connect - postgres
ALTER TABLE "Проверка" SET MAC TO '{1, 1}';
GRANT INSERT ON "Проверка" TO PUBLIC;
-- 
-- Подключение пользователя u_2_11 c меткой {2,3}
\connect - u_2_11
--
-- Пытаемся заполнить таблицу со стандартного потока ввода
-- Ожидается ошибка доступа
COPY "Проверка" FROM STDIN;
--
-- Подключение пользователя u_1_01 c меткой {1,1}
\connect - u_1_01
--
-- Пытаемся заполнить таблицу со стандартного потока ввода
-- Ожидается успех
COPY "Проверка" FROM STDIN;
1	u_1_01
\.
--
-- Подключение пользователя u_0_00 c меткой {0,0}
\connect - u_0_00
--
-- Пытаемся заполнить таблицу со стандартного потока ввода
-- Ожидается успех
COPY "Проверка" FROM STDIN;
2	u_0_00
\.
--
-- Подключается суперюзер postgres 
\connect - postgres
--
-- Откючаем мандатный контроль доступа на тестовую таблицу
ALTER TABLE "Проверка" SET MAC TO NULL;
--
-- Подключение пользователя u_2_11 c меткой {2,3}
\connect - u_2_11
--
-- Пытаемся заполнить таблицу со стандартного потока ввода
-- Ожидается успех
COPY "Проверка" FROM STDIN;
3	u_2_11
\.
--
-- Проверяем содержимое таблицы
-- Ожидаются 3 строки, метки соответствуют меткам пользователей
SELECT maclabel,* FROM "Проверка" ORDER BY "идентификатор";
--
-- Проверяем невозможность вставки метки пользователем без привилегии назначения метки CHMAC
-- Ожидается ошибка доступа
COPY "Проверка" FROM STDIN WITH MACS;
--
-- Проверяем возможность вставки метки пользователем с привилегией назначения метки CHMAC
-- Ожидается успех
\connect - dbsa
COPY "Проверка" FROM STDIN WITH MACS;
{1,0}	4	dbsa
\.
--
-- Проверяем содержимое таблицы
-- Ожидаются 4 строки
SELECT maclabel,* FROM "Проверка" ORDER BY "идентификатор";
--
\i 'support/done.sql'
