-- RBT-TEST - МПРД при удалении (DELETE)
-- Проверка работы МПРД при удалении данных командой DELETE
--
\i 'support/init.sql'
\i 'support/create-test-table.sql'
\i 'support/init-test-table.sql'
\i 'support/select-test-table.sql'
--
-- Проверяем удаление данных
--
-- Попытка удаления данных пользователем u_1_11 с меткой {1,3}
\connect - u_1_11
DELETE FROM "Проверка";
--
-- Проверяем что были удалены только записи с меткой {1,3}
-- Ожидается 8 записей
\connect - postgres
SELECT * FROM "Проверка" ORDER BY "идентификатор";
--
-- Администратор postgres устанавливает метку {1,1} на таблицу
\connect - postgres
ALTER TABLE "Проверка" SET MAC TO '{1,1}';
--
-- Проверка возможности удаления пользователями с разным уровнем
-- Попытка удаления пользователем u_0_00 с меткой {0,0}
-- Ожидается ошибка доступа
\connect - u_0_00
DELETE FROM "Проверка";
--
-- Попытка удаления пользователем u_0_01 с меткой {0,1}
-- Ожидается ошибка доступа
\connect - u_0_01
DELETE FROM "Проверка";
--
-- Попытка удаления пользователем u_1_01 с меткой {1,1}
-- Ожидается успех
\connect - u_1_01
DELETE FROM "Проверка";
--
-- Попытка удаления пользователем u_0_10 с меткой {0,2}
-- Ожидается ошибка доступа
\connect - u_0_10
DELETE FROM "Проверка";
--
-- Попытка удаления пользователем u_1_10 с меткой {1,2}
-- Ожидается ошибка доступа
\connect - u_1_10
DELETE FROM "Проверка";
--
-- Попытка удаления пользователем u_1_11 с меткой {1,3}
-- Ожидается ошибка доступа
\connect - u_1_11
DELETE FROM "Проверка";
--
-- Попытка удаления пользователем u_2_11 с меткой {2,3}
-- Ожидается ошибка доступа
\connect - u_2_11
DELETE FROM "Проверка";
--
-- Проверяем что были удалены только записи с меткой {1,1}
-- Ожидается 7 записей
\connect - postgres
SELECT * FROM "Проверка" ORDER BY "идентификатор";
--
-- Попытка удаления пользователем dbsa с флагами игнорирования МПРД
-- Ожидается успех
\connect - dbsa
DELETE FROM "Проверка";
--
-- Проверяем что были удалены все записи
-- Ожидается 0 записей
\connect - postgres
SELECT * FROM "Проверка" ORDER BY "идентификатор";

--
\i 'support/done.sql'
