-- RBT-TEST - МПРД при выборке (SELECT)
-- Проверка работы МПРД при выборке данных командой SELECT
--
\i 'support/init.sql'
\i 'support/create-test-table.sql'
\i 'support/init-test-table.sql'
\i 'support/select-test-table.sql'
--
-- Администратор postgres устанавливает метку {1, 1} на таблицу
\connect - postgres
ALTER TABLE "Проверка" SET MAC TO '{1,1}';
--
-- Проверяем выборку данных (правильность заполнения тестовой таблицы)
--
-- Выполняем запрос от имени суперпользователя postgres
-- Ожидается 10 записей
\connect - postgres
SELECT * FROM "Проверка" ORDER BY "идентификатор";
--
-- Выполняем запрос от имени пользователя u_0_00 с меткой {0,0}
-- Ожидается ошибка доступа
\connect - u_0_00
SELECT * FROM "Проверка" ORDER BY "идентификатор";
--
-- Выполняем запрос от имени пользователя u_0_01 с меткой {0,1}
-- Ожидается ошибка доступа
\connect - u_0_01
SELECT * FROM "Проверка" ORDER BY "идентификатор";
--
-- Выполняем запрос от имени пользователя u_1_01 с меткой {1,1}
-- Ожидается 5 записей
\connect - u_1_01
SELECT * FROM "Проверка" ORDER BY "идентификатор";
--
-- Выполняем запрос от имени пользователя u_0_10 с меткой {0,2}
-- Ожидается ошибка доступа
\connect - u_0_10
SELECT * FROM "Проверка" ORDER BY "идентификатор";
--
-- Выполняем запрос от имени пользователя u_1_10 с меткой {1,2}
-- Ожидается ошибка доступа
\connect - u_1_10
SELECT * FROM "Проверка" ORDER BY "идентификатор";
--
-- Выполняем запрос от имени пользователя u_1_11 с меткой {1,3}
-- Ожидается 9 записей
\connect - u_1_11
SELECT * FROM "Проверка" ORDER BY "идентификатор";
--
-- Выполняем запрос от имени пользователя u_2_11 с меткой {2,3}
-- Ожидается 10 записей
\connect - u_2_11
SELECT * FROM "Проверка" ORDER BY "идентификатор";
--
-- Выполняем запрос от имени администратора dbsa
-- Ожидается 10 записей
\connect - dbsa
SELECT * FROM "Проверка" ORDER BY "идентификатор";
--
\i 'support/done.sql'
