-- RBT-TEST - МПРД для последовательностей
-- Проверка работы МПРД для последовательностей
-- при установленном параметре разрешения использования меток последовательностей ac_enable_sequence_mac
--
\i 'support/init.sql'
\i 'support/init-config-tools.sql'
\i 'support/enable-sequence-mac.sql'
--
-- Подключение пользователя u_1_01
\connect - u_1_01
--
-- Создание последовательности
CREATE SEQUENCE "Последовательность"
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
--
-- Отключаем дискреционный контроль доступа
GRANT ALL ON "Последовательность" TO PUBLIC;
--
-- В случае установки конфигурационного параметра ac_enable_sequence_mac ожидается,
-- что метка созданной последовательности соответствует метке пользователя {1,1}
-- иначе последовательности не защищаются (метки не имеют)
SELECT relname AS "Наименование последовательности", relmaclabel AS "Метка"
FROM pg_class WHERE oid = '"Последовательность"'::regclass::oid;
--
-- Проверка выполнения SELECT
-- ожидается успех
SELECT * FROM "Последовательность";
--
-- Проверка вызова функции nextval
-- ожидается успех
SELECT nextval('"Последовательность"');
--
-- Проверка вызова функции setval
-- ожидается успех
SELECT setval('"Последовательность"', 100);
--
-- Проверка вызова функции currval
-- ожидается успех
SELECT currval('"Последовательность"');
--
-- Подключение пользователя u_1_11
\connect - u_1_11
--
-- Проверка выполнения SELECT
-- ожидается успех
SELECT * FROM "Последовательность";
--
-- Проверка вызова функции nextval
-- ожидается ошибка доступа
SELECT nextval('"Последовательность"');
--
-- Проверка вызова функции setval
-- ожидается ошибка доступа
SELECT setval('"Последовательность"', 100);
--
-- Проверка вызова функции currval
-- ожидается ошибка
SELECT currval('"Последовательность"');
--
-- Подключение пользователя u_0_00
\connect - u_0_00
--
-- Проверка выполнения SELECT
-- ожидается ошибка доступа
SELECT * FROM "Последовательность";
--
-- Проверка вызова функции nextval
-- ожидается ошибка доступа
SELECT nextval('"Последовательность"');
--
-- Проверка вызова функции setval
-- ожидается ошибка доступа
SELECT setval('"Последовательность"', 100);
--
-- Проверка вызова функции currval
-- ожидается ошибка доступа
SELECT currval('"Последовательность"');
--
\i 'support/done.sql'
