-- RBT-TEST - Проверка механизма надежного восстановления
-- Проверка механизма надежного восстановления
-- Для возможности выполнения теста, с помощью visudo для тестирующего пользователя должна быть добавлена строчка "{testuser}	ALL=NOPASSWD: /usr/bin/killall, /usr/bin/pg_ctlcluster
--
\i 'support/init.sql'
\i 'support/create-test-table.sql'
\i 'support/init-test-table.sql'
\i 'support/select-test-table.sql'
--
-- Подключается пользователь u_1_11 с меткой {1,3}
\connect - u_1_11
--
-- Создадим таблицу в пределах транзакции и внесем в нее тестовые данные
--
BEGIN;
CREATE TABLE tqual(i int, data text);
INSERT INTO tqual VALUES (1,'Подтвержденные данные');
--
-- Завершим транзакцию
COMMIT;
--
-- Проверим наличие данных в таблице
SELECT * from tqual;
--
-- Создадим еще одну таблицу в новой транзакции
-- И внесем тестовые данные в обе таблицы
BEGIN;
CREATE TABLE not_tqual(i int, data text);
INSERT INTO tqual VALUES (2,'Не подтвержденные в транзакции данные');
INSERT INTO not_tqual VALUES (1,'Также не подтвержденные в транзакции данные');
--
-- Проверим наличие данных в таблицах
-- Таблица tqual
SELECT * from tqual;
--
-- Таблица not_tqual
SELECT * from not_tqual;
--
-- Выполняем запрос от имени пользователя u_1_11 с меткой {1,3}
INSERT INTO "Проверка" VALUES (15, USER || '-insert');
--
-- Проверяем тестовую таблицу
-- Ожидается 10 записей, включая добавленную
SELECT maclabel,* FROM "Проверка" ORDER BY "идентификатор";
--
-- Уничтожим процесс сервера СУБД сигналом KILL
--
\! kill -9 $(ps ax | grep postgres | grep $PG_SETEST_CLUSTER | grep $PG_VERSION |  awk '{ print $1 }')
--
-- небольшая задержка
\! sleep 1
--
-- Проверяем, что процессов сервера не существует
\! ps aux | grep $PG_SETEST_CLUSTER | grep $PG_VERSION | grep postgres
--
-- Запускаем сервер СУБД заново
\! sudo pg_ctlcluster $PG_VERSION $PG_SETEST_CLUSTER start
--
-- Восстановим соединение и проверим наличие данных
-- небольшая задержка
\! sleep 5
--
-- Подключается пользователь u_1_11 с меткой {1,3}
\connect - u_1_11
--
-- Проверяем, что таблица tqual существует и в ней одна запись
SELECT * from tqual;
--
-- Таблица not_tqual не существует, т.к. она создавалась в рамках прерванной транзакции
-- Ожидается ошибка
SELECT * from not_tqual;
--
-- Проверяем тестовую таблицу
-- Ожидается 9 записей, так как последняя 10-я создавалась в рамках прерванной транзакции
-- Так же видно, что метки строк сохранили свои значения
SELECT maclabel,* FROM "Проверка" ORDER BY "идентификатор";
--
\i 'support/select-test-table.sql'
--
\i 'support/done.sql'
