-- RBT-TEST - ALTER TABLE
-- Проверка сохранения атрибутов безопасности при выполнении команды ALTER TABLE
--
\i 'support/init.sql'
--
-- Создаем таблицу от имени пользователя u_0_00 и заполняем еe
\connect - u_0_00
\i 'support/create-test-table.sql'
\i 'support/init-test-table.sql'
--
-- Проверяем корректность заполнения таблицы
\i 'support/select-test-table.sql'
--
-- Добавляем колонку в таблицу
\connect - u_0_00
ALTER TABLE "Проверка" ADD COLUMN "Проверочная колонка" DOUBLE PRECISION;
--
-- "Проверяем, что и данные и все права на таблицу сохранились"
\i 'support/select-test-table.sql'
--
-- Переименовываем колонку в таблице
\connect - u_0_00
ALTER TABLE "Проверка" RENAME COLUMN "Проверочная колонка" TO "Ее новое имя";
--
-- Проверяем, что и данные и все права на таблицу сохранились
\i 'support/select-test-table.sql'
--
-- Удаляем колонку из таблицы
\connect - u_0_00
ALTER TABLE "Проверка" DROP COLUMN "Ее новое имя";
--
-- Проверяем, что и данные и все права на таблицу сохранились
\i 'support/select-test-table.sql'
--
-- Переименовываем таблицу
\connect - u_0_00
ALTER TABLE "Проверка" RENAME TO "Проверка2";
--
-- Переименовываем таблицу обратно
\connect - u_0_00
ALTER TABLE "Проверка2" RENAME TO "Проверка";
--
-- Проверяем, что и данные и все права на таблицу сохранились
\i 'support/select-test-table.sql'
--
-- Проверяем невозможность удаления меток у записей таблицы
-- Ожидается ошибка доступа
\connect - postgres
ALTER TABLE "Проверка" DROP COLUMN "maclabel";
--
\i 'support/done.sql'
