-- RBT-TEST - Работа последовательностей без МПРД
-- Проверка работы последовательностей, которые не должны зависеть от МПРД
-- при сброшенном параметре разрешения использования меток последовательностей ac_enable_sequence_mac
--
\i 'support/init.sql'
\i 'support/init-config-tools.sql'
\i 'support/disable-sequence-mac.sql'
--
-- Подключение пользователя u_0_01
\connect - u_0_01
--
-- Создание последовательностей
-- Общая последовательность
CREATE SEQUENCE "Общая" START 101;
GRANT ALL ON "Общая" TO PUBLIC;
--
-- Приватная последовательность пользователя u_0_01
CREATE SEQUENCE "Частная" START 101;
--
-- Для владельца все операции разрешены
-- Изменение общей последовательности пользователем u_0_01
-- Ожидается значение 101
SELECT nextval ('"Общая"');
--
-- Текущее значение общей последовательности для пользователя u_0_01
-- Ожидается значение 101
SELECT currval ('"Общая"');
--
-- Изменение частной последовательности пользователем u_0_01
-- Ожидается значение 101
SELECT nextval ('"Частная"');
--
-- Текущее значение частной последовательности для пользователя u_0_01
-- Ожидается значение 101
SELECT currval ('"Частная"');
--
-- Подключение пользователя u_1_11
\connect - u_1_11
--
-- Работа с общей последовательностью разрешена независимо от МПРД
-- Изменение общей последовательности пользователем u_1_11
-- Ожидается значение 102
SELECT nextval ('"Общая"');
--
-- Текущее значение общей последовательности для пользователя u_1_11
-- Ожидается значение 102
SELECT currval ('"Общая"');
--
-- Работа с частной последовательностью запрещена независимо от МПРД
-- Изменение частной последовательности пользователем u_1_11
-- Ожидается ошибка доступа
SELECT nextval ('"Частная"');
--
-- Текущее значение частной последовательности для пользователя u_1_11
-- Ожидается ошибка доступа
SELECT currval ('"Частная"');
--
-- Подключение пользователя u_0_01
\connect - u_0_01
--
-- Для владельца все операции разрешены
-- Изменение общей последовательности пользователем u_0_01
-- Ожидается значение 103
SELECT nextval ('"Общая"');
--
-- Текущее значение общей последовательности для пользователя u_0_01
-- Ожидается значение 103
SELECT currval ('"Общая"');
--
-- Изменение частной последовательности пользователем u_0_01
-- Ожидается значение 102
SELECT nextval ('"Частная"');
--
-- Текущее значение частной последовательности для пользователя u_0_01
-- Ожидается значение 102
SELECT currval ('"Частная"');
--
-- Подключение пользователя u_0_00
\connect - u_0_00
--
-- Работа с общей последовательностью разрешена независимо от МПРД
-- Изменение общей последовательности пользователем u_0_00
-- Ожидается значение 104
SELECT nextval ('"Общая"');
--
-- Текущее значение общей последовательности для пользователя u_0_00
-- Ожидается значение 104
SELECT currval ('"Общая"');
--
-- Работа с частной последовательностью запрещена независимо от МПРД
-- Изменение частной последовательности пользователем u_0_00
-- Ожидается ошибка доступа
SELECT nextval ('"Частная"');
--
-- Текущее значение частной последовательности для пользователя u_0_00
-- Ожидается ошибка доступа
SELECT currval ('"Частная"');
--
\i 'support/done.sql'
